unit UJEDemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ValEdit, ExtCtrls, StdCtrls, Buttons, UJSONExpr, Menus;

type
  TfrmMain = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Splitter1: TSplitter;
    Panel2: TPanel;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Panel3: TPanel;
    valEditor: TValueListEditor;
    VarMemo: TMemo;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    DemoExpressions1: TMenuItem;
    Singlenumber1: TMenuItem;
    Simple1: TMenuItem;
    String1: TMenuItem;
    General1: TMenuItem;
    Number1: TMenuItem;
    IF1: TMenuItem;
    Collection1: TMenuItem;
    Collection2: TMenuItem;
    About1: TMenuItem;
    AdvancedDemo1: TMenuItem;
    Collection21: TMenuItem;
    Assignment1: TMenuItem;
    Demo11: TMenuItem;
    Variables1: TMenuItem;
    Clean1: TMenuItem;
    CheckAll1: TMenuItem;
    Demo21: TMenuItem;
    Collection31: TMenuItem;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure VarMemoChange(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure Singlenumber1Click(Sender: TObject);
    procedure String1Click(Sender: TObject);
    procedure Number1Click(Sender: TObject);
    procedure IF1Click(Sender: TObject);
    procedure Collection1Click(Sender: TObject);
    procedure Collection2Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Assignment1Click(Sender: TObject);
    procedure Collection21Click(Sender: TObject);
    procedure Demo11Click(Sender: TObject);
    procedure Clean1Click(Sender: TObject);
    procedure CheckAll1Click(Sender: TObject);
    procedure Demo21Click(Sender: TObject);
    procedure Collection31Click(Sender: TObject);
  private
    { Private declarations }
  public
    Parser:TJSONExprParser;
    VHelper:TSimpleVarHelper;
    procedure AfterEval;
    procedure VarHelperToValList;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

{$D+}

uses
  uJSON, JSONExprTester;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Parser:=TJSONExprParser.Create;
  VHelper:=TSimpleVarHelper.Create;
  Parser.AddVarHelper(VHelper);
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  Parser.Free;
  VHelper.Free;
end;

procedure TfrmMain.About1Click(Sender: TObject);
begin
  MessageDlg('JSON Expression Parser && Evaluator'#13#10'By creaiton_zy@sina.com   2009', mtInformation, [mbOK], 0);
end;

procedure TfrmMain.BitBtn1Click(Sender: TObject);
var
  J:JSONObject;
begin
  J:=TJSONExprParser.ExprToJSON(Memo1.Text);
  if J=nil then
    Memo2.Text:=''
  else begin
    Memo2.Text:=StringReplace(J.ToString2(2),#10,#13#10,[rfReplaceAll]);
    J.Free;
  end;
end;

procedure TfrmMain.BitBtn2Click(Sender: TObject);
var
  J:JSONObject;
begin
  try
    J:=JSONObject.Create(Memo2.Text);
  except
    Memo2.SetFocus;
    MessageDlg('Invalid JSON !', mtError, [mbOK], 0);
    exit;
  end;
  Memo1.Text:=TJSONExprParser.JSONToExpr(J,0);  
end;

procedure TfrmMain.BitBtn3Click(Sender: TObject);
var
  J:JSONObject;
  v:Variant;
begin
  try
    J:=JSONObject.Create(Memo2.Text);
  except
    Memo2.SetFocus;
    Memo2.SelectAll;
    MessageDlg('Invalid JSON text!', mtError, [mbOK], 0);
    exit;
  end;
  if J=nil then exit;
  v:=Parser.Eval(J);
  AfterEval;
  MessageDlg(Format('The result of expression is: %s',[VarToStrDef(v,'N/A')]), mtInformation, [mbOK], 0);
end;

procedure TfrmMain.BitBtn4Click(Sender: TObject);
var
  J:JSONObject;
  v:Double;
  mstr:String;
begin
  J:=JSONObject.Create(Memo2.Text);
  if J=nil then exit;
  if not Parser.EvalNumber(J,v) then
    mstr:='N/A'
  else
    mstr:=FloatToStr(v);
  AfterEval;
  MessageDlg(Format('The result of expression is: %s',[VarToStrDef(v,'N/A')]), mtInformation, [mbOK], 0);
end;

procedure TfrmMain.Timer1Timer(Sender: TObject);
var
  J:JSONObject;
begin
  Timer1.Enabled:=false;
  try
    J:=JSONObject.Create(VarMemo.Text);
  except
    exit;
  end;
  valEditor.Strings.Clear;
  with VHelper do
  begin
    Clean;
    ValImport(J);
  end;
  J.Free;
  VarHelperToValList;
end;

procedure TfrmMain.VarMemoChange(Sender: TObject);
begin
  if VarMemo.Enabled then
    Timer1.Enabled:=true
  else
    Timer1.Enabled:=false;
end;

procedure TfrmMain.AfterEval;
var
  J:JSONObject;
begin
  J:=JSONObject.Create;
  VHelper.ValExport(J);
  with VarMemo do
  begin
    Enabled:=false;
    Text:=StringReplace(J.ToString2(2),#10,#13#10,[rfReplaceAll]);
    Enabled:=true;
  end;
  VarHelperToValList;
end;

procedure TfrmMain.Assignment1Click(Sender: TObject);
begin
  Memo1.Text:='X:=4<<(3+2)';
end;

procedure TfrmMain.VarHelperToValList;
var
  i:Integer;
  mstr,vstr:String;
begin
  valEditor.Strings.Clear;
  with VHelper do
  begin
    for i:=0 to Pred(VarCount) do
    begin
      mstr:=VarNames[i];
      vstr:=VarToStrDef(GetVarDef(mstr,Null),'');
      ValEditor.InsertRow(mstr,vstr,true);
    end;
  end;
end;

procedure TfrmMain.Singlenumber1Click(Sender: TObject);
begin
  Memo1.Text:='360+0.2*80';
end;

procedure TfrmMain.String1Click(Sender: TObject);
begin
  Memo1.Text:='''Hello''+#32+''World!''';
end;

procedure TfrmMain.Number1Click(Sender: TObject);
begin
  Memo1.Text:='360\80 + (24^10)%10';
end;

procedure TfrmMain.IF1Click(Sender: TObject);
begin
  Memo1.Text:='IF( 3>=5-2, 333, 98-76-3)';
end;

procedure TfrmMain.Clean1Click(Sender: TObject);
begin
  VarMemo.Text:='{}';
  with VHelper do
  begin
    Clean;
  end;
  VarHelperToValList;
end;

procedure TfrmMain.Collection1Click(Sender: TObject);
begin
  Memo1.Text:='4 IN ( (2,3,4,6,8,5+5) & (8-2, 6>>1, 2<<1) )';
end;

procedure TfrmMain.Collection21Click(Sender: TObject);
begin
  Memo1.Text:='(1,2,3,4,6) > ( (0,1,2,3) & (1,3,5,7)) )';
end;

procedure TfrmMain.Collection2Click(Sender: TObject);
begin
  Memo1.Text:='9 IN (3,6,9)';
end;

procedure TfrmMain.Collection31Click(Sender: TObject);
begin
  Memo1.Text:='Len( (2,3,4,6) - ((1,2)|(1,3,5,7)) )';
end;

procedure TfrmMain.Demo11Click(Sender: TObject);
begin
  Memo1.Text:='Y:=Null; X:=3; IF(Y IS not NULL, 3*0.5+Y, 5.875-(9<<2)*X)';
end;

procedure TfrmMain.Demo21Click(Sender: TObject);
begin
  Memo1.Text:='X1:=1; Y:=IF(X IS NULL,0,X1^5);Z:=9*IF(X1+2<=(3+Y),X2:=X1<<3,(Y:=X1*10; X2:=Y^100));(Y+Z)*X2';
end;

procedure TfrmMain.CheckAll1Click(Sender: TObject);
var
  msg:String;
begin
  if not JSONExprTester.TestJSONExprParser(Msg) then
    MessageDlg('-------- Test Failed! --------'#13#10#13#10+msg,mtWarning,[mbOK],0)
  else
    MessageDlg('-------- Test OK! --------'#13#10#13#10+msg,mtInformation,[mbOK],0);
end;

end.
